﻿using System;
using System.Collections.Generic;

namespace TestModelForm
{
    public class EasyAI
    {

        enum Piece { White = 1, Black };
        private int _playingColor;
        private BoardModel _model;


        public EasyAI(int color, BoardModel model)
        {
            _playingColor = color;
            _model = model;
        }

        public Square getComputerMove()
        {
            // basic AI chooses move that flips most pieces
            // need to add in some heuristics for corner, near corner, safe pieces etc.
            _model.loadLegalMoves(_playingColor);
            _model.legalMovesList.Shuffle();
            int bestScore = -1;
            Square bestMove = new Square(-1, -1);

            foreach (Square temp in _model.legalMovesList)
            {
                _model.loadPiecesToFlip(_playingColor, temp.x, temp.y);
                if (_model.piecesToFlipList.Count > bestScore)
                {
                    bestMove = temp;
                    bestScore = _model.piecesToFlipList.Count;
                }
            }

            return bestMove;          
        }

    }

    static class MyExtensions
    {
        // standard Fisher-Yates shuffle example from StackOverflow.
        static readonly Random Random = new Random();
        public static void Shuffle<T>(this IList<T> list)
        {
            int n = list.Count;
            while (n > 1)
            {
                n--;
                int k = Random.Next(n + 1);
                T value = list[k];
                list[k] = list[n];
                list[n] = value;
            }
        }
    }
}
